<template>
  <div class="subscription-column__points">
    <div
      v-if="items.length"
      class="subscription-column__points-items"
    >
      <Tab
        v-for="item in itemsVisible"
        :key="item"
        :name="transformNameByUuid(item)"
        :icon="'city-sm'"
        :toggle="toggle"
        @click="$emit('remove', {uuid: item, subscription: subscription})"
      />
      <button
          v-if="itemsHidden.length"
          class="button"
          @click="showOtherItems('show')"
      >
        еще {{ itemsHidden.length }}
      </button>
      <button
          v-if="limit > 10"
          class="button"
          @click="showOtherItems('hide')"
      >
        скрыть
      </button>
    </div>
    <div
      v-else
      class="subscription-column__points-empty"
    >
      -
    </div>
  </div>
</template>

<script>
  import Tab from './tab';
  import { mapGetters } from "vuex";
  export default {
    name: 'SubscriptionPoints',
    components: {
      Tab,
    },
    props: {
      items: {
        type: Array,
        default: () => []
      },
      subscription: {
        type: Object,
        default: () => {}
      },
      toggle: {
        type: Boolean,
        default: true
      }
    },
    data() {
      return {
        limit: 10
      }
    },
    computed: {
      ...mapGetters({
        listLocations: 'subscriptions/listLocations'
      }),
      itemsVisible() {
        return this.items.slice(0, this.limit);
      },
      itemsHidden() {
        if (this.items.length === this.itemsVisible.length) {
          return [];
        }
        return this.items.slice(10, this.items.length);
      },
    },
    methods: {
      showOtherItems (type) {
        if (type === 'show') {
          this.limit = this.items.length
        } else{
          this.limit = 10
        }
      },
      transformNameByUuid (uuid) {
        const city = this.listLocations.find(key => key.uuid === uuid);
        if (city) {
          return city.russianName;
        }
      }
    }
  };
</script>

<style lang="scss">
  .subscription-column__points {
    width: 740px;
    &-items {
      display: flex;
      flex-wrap: wrap;
    }
    &-empty {
      padding-left: 5px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $gray-window;
    }
  }

  .button {
    width: 68px !important;
    border: none;
    margin: 0 5px;
    padding: 0;
    overflow: visible;
    background: transparent;
    font: inherit;
    -webkit-font-smoothing: inherit;
    -moz-osx-font-smoothing: inherit;
    font-size: 14px;
    line-height: 20px;
    color: $color-blue-navy-blue;
    cursor: pointer;
  }
</style>
